/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import AvailablePairs from '../model/AvailablePairs';
import HTTPValidationError from '../model/HTTPValidationError';
import PairHistory from '../model/PairHistory';
import PlotConfig from '../model/PlotConfig';

/**
* CandleData service.
* @module ftclient/CandleDataApi
* @version 2021.12-dev21
*/
export default class CandleDataApi {

    /**
    * Constructs a new CandleDataApi. 
    * @alias module:ftclient/CandleDataApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * List Available Pairs
     * @param {Object} opts Optional parameters
     * @param {String} opts.timeframe 
     * @param {String} opts.stakeCurrency 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/AvailablePairs} and HTTP response
     */
    listAvailablePairsApiV1AvailablePairsGetWithHttpInfo(opts) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
        'timeframe': opts['timeframe'],
        'stake_currency': opts['stakeCurrency']
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = AvailablePairs;
      return this.apiClient.callApi(
        '/api/v1/available_pairs', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * List Available Pairs
     * @param {Object} opts Optional parameters
     * @param {String} opts.timeframe 
     * @param {String} opts.stakeCurrency 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/AvailablePairs}
     */
    listAvailablePairsApiV1AvailablePairsGet(opts) {
      return this.listAvailablePairsApiV1AvailablePairsGetWithHttpInfo(opts)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Pair Candles
     * @param {String} pair 
     * @param {String} timeframe 
     * @param {Number} limit 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PairHistory} and HTTP response
     */
    pairCandlesApiV1PairCandlesGetWithHttpInfo(pair, timeframe, limit) {
      let postBody = null;
      // verify the required parameter 'pair' is set
      if (pair === undefined || pair === null) {
        throw new Error("Missing the required parameter 'pair' when calling pairCandlesApiV1PairCandlesGet");
      }
      // verify the required parameter 'timeframe' is set
      if (timeframe === undefined || timeframe === null) {
        throw new Error("Missing the required parameter 'timeframe' when calling pairCandlesApiV1PairCandlesGet");
      }
      // verify the required parameter 'limit' is set
      if (limit === undefined || limit === null) {
        throw new Error("Missing the required parameter 'limit' when calling pairCandlesApiV1PairCandlesGet");
      }

      let pathParams = {
      };
      let queryParams = {
        'pair': pair,
        'timeframe': timeframe,
        'limit': limit
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = PairHistory;
      return this.apiClient.callApi(
        '/api/v1/pair_candles', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Pair Candles
     * @param {String} pair 
     * @param {String} timeframe 
     * @param {Number} limit 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PairHistory}
     */
    pairCandlesApiV1PairCandlesGet(pair, timeframe, limit) {
      return this.pairCandlesApiV1PairCandlesGetWithHttpInfo(pair, timeframe, limit)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Pair History
     * @param {String} pair 
     * @param {String} timeframe 
     * @param {String} timerange 
     * @param {String} strategy 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PairHistory} and HTTP response
     */
    pairHistoryApiV1PairHistoryGetWithHttpInfo(pair, timeframe, timerange, strategy) {
      let postBody = null;
      // verify the required parameter 'pair' is set
      if (pair === undefined || pair === null) {
        throw new Error("Missing the required parameter 'pair' when calling pairHistoryApiV1PairHistoryGet");
      }
      // verify the required parameter 'timeframe' is set
      if (timeframe === undefined || timeframe === null) {
        throw new Error("Missing the required parameter 'timeframe' when calling pairHistoryApiV1PairHistoryGet");
      }
      // verify the required parameter 'timerange' is set
      if (timerange === undefined || timerange === null) {
        throw new Error("Missing the required parameter 'timerange' when calling pairHistoryApiV1PairHistoryGet");
      }
      // verify the required parameter 'strategy' is set
      if (strategy === undefined || strategy === null) {
        throw new Error("Missing the required parameter 'strategy' when calling pairHistoryApiV1PairHistoryGet");
      }

      let pathParams = {
      };
      let queryParams = {
        'pair': pair,
        'timeframe': timeframe,
        'timerange': timerange,
        'strategy': strategy
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = PairHistory;
      return this.apiClient.callApi(
        '/api/v1/pair_history', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Pair History
     * @param {String} pair 
     * @param {String} timeframe 
     * @param {String} timerange 
     * @param {String} strategy 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PairHistory}
     */
    pairHistoryApiV1PairHistoryGet(pair, timeframe, timerange, strategy) {
      return this.pairHistoryApiV1PairHistoryGetWithHttpInfo(pair, timeframe, timerange, strategy)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * Plot Config
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PlotConfig} and HTTP response
     */
    plotConfigApiV1PlotConfigGetWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = ['HTTPBasic', 'OAuth2PasswordBearer'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = PlotConfig;
      return this.apiClient.callApi(
        '/api/v1/plot_config', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * Plot Config
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PlotConfig}
     */
    plotConfigApiV1PlotConfigGet() {
      return this.plotConfigApiV1PlotConfigGetWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
